﻿using System;

class Program
{
    static void Main(string[] args)
    {
        {
            Product prd = new Headset().GetDevice();
            Console.WriteLine(prd.GetType().FullName);
        }

        {
            Headset prd = new Headset().GetDevice();
            Console.WriteLine(prd.GetType().FullName);
        }
    }
}

public class Product
{
    public virtual Product GetDevice() { return this; }
}

public class Headset : Product
{
    public short Purchase(int count) { return 0; }

    // Error CS0111 Type 'Headset' already defines a member called 'Purchase' with the same parameter types
    // public int Purchase(int count) { return 0; }

    // C# 8.0 이전에는 컴파일 오류
    // Error CS0508 'Headset.GetDevice()': return type must be 'Product' to match overridden member 'Product.GetDevice()'
    public override Headset GetDevice()
    {
        return this;
    }
}
